'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactRedux = require('react-redux');

var _selector = require('./selector');

var _action = require('./action');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (renderMap) {
  return function (WrappedComponent) {
    var Connect = function (_Component) {
      _inherits(Connect, _Component);

      function Connect() {
        _classCallCheck(this, Connect);

        return _possibleConstructorReturn(this, (Connect.__proto__ || Object.getPrototypeOf(Connect)).apply(this, arguments));
      }

      _createClass(Connect, [{
        key: 'render',
        value: function render() {
          var _this2 = this;

          var mergedProps = _extends({}, this.props, {
            components: [].concat(_toConsumableArray(this.context.relocation.components || []), _toConsumableArray(this.props.components.map(function (item) {
              return _extends({
                // Assign default remove functions.
                remove: function remove() {
                  return _this2.props.remove(item.id);
                }
              }, item);
            })))
            // Remove components not included in the render function map.
            .filter(function (item) {
              return renderMap.hasOwnProperty(item.type);
            })

            // Assign render functions.
            .map(function (item) {
              return _extends({
                render: renderMap[item.type]
              }, item);
            })
          });

          return (0, _react.createElement)(WrappedComponent, mergedProps);
        }
      }]);

      return Connect;
    }(_react.Component);

    Connect.propTypes = {
      list: _react.PropTypes.arrayOf(_util.componentShape)
    };
    Connect.contextTypes = {
      relocation: _util.contextShape
    };
    Connect.defaultProps = {
      list: []
    };


    Connect.displayName = 'Relocation(' + (0, _util.getDisplayName)(WrappedComponent) + ')';

    var mapState = function mapState(state, props) {
      return {
        components: (0, _selector.getComponents)(state, props)
      };
    };
    var mapDispatch = function mapDispatch(dispatch) {
      return {
        remove: function remove(id) {
          return dispatch((0, _action.remove)(id));
        }
      };
    };

    return (0, _reactRedux.connect)(mapState, mapDispatch)((0, _hoistNonReactStatics2.default)(Connect, WrappedComponent));
  };
};
//# sourceMappingURL=connect.js.map