'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRouterComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _reactRouter = require('react-router');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _provider = require('./provider');

var _provider2 = _interopRequireDefault(_provider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getDisplayName = function getDisplayName(C) {
  return C.displayName || C.name || 'Component';
};

var createRouterComponent = exports.createRouterComponent = function createRouterComponent(WrappedComponent) {
  var Connect = function (_Component) {
    _inherits(Connect, _Component);

    function Connect(state, props) {
      _classCallCheck(this, Connect);

      var _this = _possibleConstructorReturn(this, (Connect.__proto__ || Object.getPrototypeOf(Connect)).call(this, state, props));

      _this.state = { previousLocation: {} };
      return _this;
    }

    _createClass(Connect, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps() {
        this.setState({ previousLocation: this.props.location });
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props;
        var routes = _props.routes;
        var params = _props.params;
        var router = this.context.router;

        // Create a function that will remove the component by navigating to a
        // different path. Call `router.replace` with `item.hide` if it is
        // defined, otherwise call router.replace with the formatted path of the
        // parent route.

        var createRemove = function createRemove(i) {
          var path = routes[i].relocation.remove;

          if (!path) {
            var parentPath = void 0;

            for (var current = i - 1; !parentPath && i >= 0; current--) {
              var parent = routes[current];
              parentPath = parent && parent.path;
            }

            if (parentPath) {
              path = (0, _reactRouter.formatPattern)(parentPath, params);
            }
          }

          if (!path) {
            return null;
          }

          return function () {
            if (path === _this2.state.previousLocation.pathname) {
              router.goBack();
            } else {
              router.push(path);
            }
          };
        };

        var components = routes.reduce(function (components, route, i) {
          var relocation = route.relocation;
          var path = route.path;


          if (relocation) {
            components.push(_extends({
              // Use the formatted path that matched as the default id.
              id: (0, _reactRouter.formatPattern)(path, params),

              // Merge component props with redux-router props.
              props: _extends({}, _this2.props, relocation.props)

            }, typeof relocation === 'string' ? { type: relocation } : relocation, {

              // Assign a remove function. Use `route.relocation.remove`
              // if it's a function.
              remove: typeof relocation.remove === 'function' ? relocation.remove : createRemove(i)
            }));
          }

          return components;
        }, []);

        return (0, _react.createElement)(WrappedComponent, _extends({ components: components }, this.props));
      }
    }]);

    return Connect;
  }(_react.Component);

  Connect.propTypes = {
    routes: _react.PropTypes.array.isRequired,
    params: _react.PropTypes.object.isRequired
  };
  Connect.contextTypes = {
    router: _reactRouter.routerShape
  };


  Connect.displayName = 'RelocationRouter(' + getDisplayName(WrappedComponent) + ')';

  return (0, _hoistNonReactStatics2.default)(Connect, WrappedComponent);
};

exports.default = createRouterComponent(_provider2.default);
//# sourceMappingURL=router.js.map