'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.contextShape = exports.componentsShape = exports.componentShape = exports.renderMapShape = exports.renderShape = exports.getDisplayName = undefined;

var _react = require('react');

var getDisplayName = exports.getDisplayName = function getDisplayName(C) {
  return C.displayName || C.name || 'Component';
};

var renderShape = exports.renderShape = _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]);

var renderMapShape = exports.renderMapShape = _react.PropTypes.objectOf(renderShape);

var componentShape = exports.componentShape = _react.PropTypes.shape({
  id: _react.PropTypes.string.isRequired,
  type: _react.PropTypes.string.isRequired,
  props: _react.PropTypes.object,
  hide: _react.PropTypes.func,
  render: renderShape
});

var componentsShape = exports.componentsShape = _react.PropTypes.arrayOf(componentShape);

var contextShape = exports.contextShape = _react.PropTypes.shape({
  components: componentsShape.isRequired
});
//# sourceMappingURL=util.js.map